//---------------------------------------------------------------------------

#include <vcl.h>
#include "ITSSkinF.h"
#include "ITSUtilF.h"
#include "AppGlobalF.h"
#include "ITSLangTransF.h"
#pragma hdrstop

#include "WCAMH10MF.h"
#include "WCAMH101F.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cxButtons"
#pragma link "cxCalendar"
#pragma link "cxContainer"
#pragma link "cxControls"
#pragma link "cxDropDownEdit"
#pragma link "cxEdit"
#pragma link "cxGraphics"
#pragma link "cxGroupBox"
#pragma link "cxLabel"
#pragma link "cxLookAndFeelPainters"
#pragma link "cxLookAndFeels"
#pragma link "cxMaskEdit"
#pragma link "cxPC"
#pragma link "cxPCdxBarPopupMenu"
#pragma link "cxSpinEdit"
#pragma link "cxSplitter"
#pragma link "cxTextEdit"
#pragma link "cxTimeEdit"
#pragma link "dxSkinBlack"
#pragma link "dxSkinBlue"
#pragma link "dxSkinsCore"
#pragma link "dxSkinscxPCPainter"
#pragma link "FRAME_WCamListF"
#pragma link "dxSkinMcSkin"
#pragma resource "*.dfm"

TWCAMH10M *WCAMH10M = NULL;
//---------------------------------------------------------------------------
__fastcall TWCAMH10M::TWCAMH10M(TComponent* Owner)
    : TForm(Owner)
{
    LangTrans->Translate(this, ITSDb_GetConnection());
    ITSSkin_Load(this);
    CMM_LoadForm(g_sFormsDir, this);

    FTitle = Caption;//"VDS-제어기 상태 이력조회";
    m_pFormList = new TList(); 
    TsList01->TabVisible = false;

    FRAMEWCamList1->PnlBottom->Visible = false;
    FRAMEWCamList1->ColumnSel->Visible = true;
    FRAMEWCamList1->Column05->Visible = false;
    FRAMEWCamList1->Column07->Visible = false;
    FRAMEWCamList1->Column08->Visible = false;
    FRAMEWCamList1->Column10->Visible = false;
    FRAMEWCamList1->Column11->Visible = false;
    FRAMEWCamList1->Column12->Visible = false;
}
//---------------------------------------------------------------------------

void __fastcall TWCAMH10M::CommClose()
{
    try
    {
        for (int idx = m_pFormList->Count-1; idx >= 0; idx--)
        {
            m_pFormList->Delete(idx);
        }
        delete m_pFormList;

        CMM_SaveForm(g_sFormsDir, this);
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------

void __fastcall TWCAMH10M::FormShow(TObject *Sender)
{
    Refresh();
    FormInit();
    TmrShow->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TWCAMH10M::FormInit()
{
    DtStDate->Date = Now() - 1;
    DtEdDate->Date = Now() - 1;
    //DtEdTime->EditValue = Now().FormatString("hh");
    DtStTime->Time = StrToDateTime("00:00");
    DtEdTime->Time = StrToDateTime("23:59");
}
//---------------------------------------------------------------------------

void __fastcall TWCAMH10M::TmrShowTimer(TObject *Sender)
{
    TmrShow->Enabled = false;

    FRAMEWCamList1->UpdateList();
}
//---------------------------------------------------------------------------

void __fastcall TWCAMH10M::RefreshData()
{
    // 검색조건에 의한 링크 데이터 조회
    try
    {
        //SelListData();
	}
	__finally
	{
	}
}
//---------------------------------------------------------------------------

void __fastcall TWCAMH10M::BtnSearchClick(TObject *Sender)
{
    Application->ProcessMessages();
    TSqlCursor sqlCrs((TControl*)BtnSearch);

#if 0
	FStDateTime = DtStDate->Date.FormatString("yyyymmdd") + DtStTime->Time.FormatString("hh");
	FEdDateTime = DtEdDate->Date.FormatString("yyyymmdd") + DtEdTime->Time.FormatString("hh");
#else
	FStDateTime = DtStDate->Date.FormatString("yyyymmdd") + DtStTime->Time.FormatString("hhnn");
	FEdDateTime = DtEdDate->Date.FormatString("yyyymmdd") + DtEdTime->Time.FormatString("hhnn");
#endif
    if (FStDateTime > FEdDateTime)
    {
        Application->MessageBox(FrmLang->lblQryDtErr->Caption.c_str(),//L"검색 시작시각이 검색 종료시각 보다 큽니다.",
                                FTitle.c_str(), MB_OK|MB_ICONWARNING|MB_APPLMODAL);
        ActiveControl = DtStDate;
        return;
    }
#if 0
    FStDateTime = FStDateTime + "0000";
    FEdDateTime = FEdDateTime + "5959";
#else
    FStDateTime = FStDateTime + "00";
    FEdDateTime = FEdDateTime + "59";
#endif

    FIdList = "";
    int nSelects = CMM_GetSelectCount(FRAMEWCamList1->TvList, FRAMEWCamList1->ColumnSel->Index, FRAMEWCamList1->Column01->Index, FIdList);
    if (0 == nSelects)
    {
        Application->MessageBox(FrmLang->lblSelLstErr->Caption.c_str(),//L"검색 목록을 선택하지 않았습니다.",
                                FTitle.c_str(), MB_OK|MB_ICONWARNING|MB_APPLMODAL);
        FRAMEWCamList1->CxList->SetFocus();
        return;
    }

#if 0
    String sTitle = "[" + FStDateTime + "-" + FEdDateTime + "]";
#else
    String sTitle = CMM_GetSelectTitle(FRAMEWCamList1->TvList, FRAMEWCamList1->ColumnSel->Index, FRAMEWCamList1->Column03->Index);
#endif

    try
    {
        Application->ProcessMessages();
        LockWindowUpdate(Handle);

        TcxTabSheet *pSheet = CMM_AddTabSheet(PgTab, sTitle);
        if (!pSheet) return;

        WCAMH101 = new TWCAMH101(this, Handle, FStDateTime, FEdDateTime, FIdList);
        WCAMH101->Parent = pSheet;
        WCAMH101->Show();
        PgTab->ActivePage = pSheet;
        pSheet = PgTab->ActivePage;
        m_pFormList->Add(WCAMH101);
    }
    __finally
    {
        LockWindowUpdate(0);
    }
}
//---------------------------------------------------------------------------

void __fastcall TWCAMH10M::BtnCloseClick(TObject *Sender)
{
    Close();    
}
//---------------------------------------------------------------------------

void __fastcall TWCAMH10M::OnSubFormClose(TMessage Msg)
{
    int nActiveIdx = PgTab->ActivePageIndex;
    if (nActiveIdx <= 0) return;

    LockWindowUpdate(Handle);

    TcxTabSheet *pSheet = PgTab->ActivePage;
    if (pSheet)
    {
        delete pSheet;
    }
    nActiveIdx--;   // 첫번째 탭은 화면에 숨겨져 있다.
    m_pFormList->Delete(nActiveIdx);

    LockWindowUpdate(0);
}
//---------------------------------------------------------------------------

void __fastcall TWCAMH10M::PgTabDblClick(TObject *Sender)
{
    TPoint APoint;
    APoint = PgTab->MouseDownPos;
    if (PgTab->IndexOfTabAt(APoint.x, APoint.y) != -1)
        POST_MSG(Handle, WM_SUBFORM_CLOSE, 0, 0);
}
//---------------------------------------------------------------------------

void __fastcall TWCAMH10M::FormClose(TObject *Sender, TCloseAction &Action)
{
    CommClose();
    WCAMH10M = NULL;
    Action = caFree;    
}
//---------------------------------------------------------------------------

void __fastcall TWCAMH10M::FormCloseQuery(TObject *Sender, bool &CanClose)
{
    FRAMEWCamList1->OnCloseQuery(CanClose);
}
//---------------------------------------------------------------------------

void __fastcall TWCAMH10M::PgTabCanCloseEx(TObject *Sender, int ATabIndex, bool &ACanClose)
{
    int nActiveIdx = ATabIndex;
    if (nActiveIdx <= 0) return;

    nActiveIdx--;   // 첫번째 탭은 화면에 숨겨져 있다.
    m_pFormList->Delete(nActiveIdx);
}
//---------------------------------------------------------------------------

